module Jok
  class JokeFactory
    BASE_URI =  "http://www.laughfactory.com/jokes/".freeze

    def list
      @list ||= begin
        Nokogiri::HTML(HTTParty.get(BASE_URI)).xpath('//div[@class="left-nav"]/ul/li/a').map(&:text)
      end
    end

    def da
      topic = method_list[srand % method_list.length]
      joke(topic)
    end

    def method_missing(method, *args, &block)
      method = method.to_s
      super unless method_list.include? method

      self.class.class_eval <<-EOT, __FILE__, __LINE__ + 1
      def #{method}
        @#{method} ||= begin
          joke("#{method}")
        end
      end
      EOT

      send method
    end

    def method_list
      @method_list ||= begin
        list.map do |element|
          element.split(" ").map(&:downcase).join("_")
        end.push "da"
      end
    end

    private

    # Cautious: Randomness!!!
    def parse_uri(method="")
      topic = "#{BASE_URI}#{method.gsub("_", "-")}"
      response_body = HTTParty.get(topic)

      return topic if method == ""

      dom_tree = Nokogiri::HTML(response_body)

      pagination_items = dom_tree.xpath('//div[@class="pagination"]/ul/li').map(&:text).map(&:strip)

      if pagination_items.length > 0
        selected_item = pagination_items[srand % (pagination_items.length - 1)]
        "#{topic}/#{selected_item}"
      else
        topic
      end
    end

    def joke(topic="")
      uri = parse_uri(topic)
      response_body = HTTParty.get(uri)
      dom = Nokogiri::HTML(response_body).xpath('//div[@class="joke3-pop-box"]/p[substring-before(@id, "_") = "joke"]')

      dom.map do |child|
        OpenStruct.new(content: child.text.strip, link: "#{uri}##{child.attributes["id"].value}")
      end
    end
  end
end
